declare type MaybeString = string | null | undefined | boolean;
declare type HookTypes = "$all" | "$always" | "$none" | "$nil" | "$notnil";
declare type Hooks = {
    [key in HookTypes]?: MaybeString | Variations;
};
declare type HooksWithForward = Hooks & {
    $forward?: MaybeString;
};
export declare type Variations = Hooks & {
    [key: string]: MaybeString | Variations;
};
export declare type RootVariations = HooksWithForward & Variations;
export declare type Source = {
    className?: MaybeString;
    [key: string]: any;
};
export declare function get(prop: string, valueVariations: Variations | MaybeString, source: Source): Exclude<MaybeString, boolean>;
declare function classnames(variations: RootVariations, ...inputs: Array<Source | null | undefined>): string;
export declare function classnamesWithScope<T extends Record<string, any>>(scope: T, input: Source | null | undefined): Record<keyof T, string>;
export { classnames as vc, classnamesWithScope as vcs };
export default classnames;
